import {AdminNotificationFormPresentational} from "@admin/notification/components/presentationals/admin-notification-form/admin-notification-form.presentational";
import {AdminNotificationDetailEditRoutable} from "@admin/notification/components/routables/admin-notification-detail-edit/admin-notification-detail-edit.routable";
import {AdminNotificationListRoutable} from "@admin/notification/components/routables/admin-notification-list/admin-notification-list.routable";
import {AdminNotificationRoutingModule} from "@admin/notification/notification-routing.module";
import {AdminNotificationState} from "@admin/notification/stores/admin-notification.state";
import {NgModule} from "@angular/core";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";
import {AdminNotificationStatusHistoryState} from "@admin/notification/stores/status-history/admin-notification-status-history.state";

const routables = [
  AdminNotificationListRoutable,
  AdminNotificationDetailEditRoutable,
];
const containers = [];
const dialogs = [];
const presentationals = [
  AdminNotificationFormPresentational,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    AdminNotificationRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      AdminNotificationState,
      AdminNotificationStatusHistoryState
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class AdminNotificationModule {
}
