import {AdminOrgunitDeleteDialog} from "@admin/orgunit/components/dialogs/admin-orgunit-delete/admin-orgunit-delete.dialog";
import {AdminOrgunitFormPresentational} from "@admin/orgunit/components/presentationals/admin-orgunit-form/admin-orgunit-form.presentational";
import {AdminOrgunitCreateRoutable} from "@admin/orgunit/components/routables/admin-orgunit-create/admin-orgunit-create.routable";
import {AdminOrgunitDetailEditRoutable} from "@admin/orgunit/components/routables/admin-orgunit-detail-edit/admin-orgunit-detail-edit.routable";
import {AdminOrgunitListRoutable} from "@admin/orgunit/components/routables/admin-orgunit-list/admin-orgunit-list.routable";
import {AdminOrgunitRoutingModule} from "@admin/orgunit/orgunit-routing.module";
import {AdminOrganizationalUnitState} from "@admin/orgunit/stores/admin-organizational-unit.state";
import {NgModule} from "@angular/core";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";

const routables = [
  AdminOrgunitCreateRoutable,
  AdminOrgunitDetailEditRoutable,
  AdminOrgunitListRoutable,
];
const containers = [];
const dialogs = [
  AdminOrgunitDeleteDialog,
];
const presentationals = [
  AdminOrgunitFormPresentational,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    AdminOrgunitRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      AdminOrganizationalUnitState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class AdminOrgunitModule {
}
