import {
  ChangeDetectionStrategy,
  Component,
  Inject,
  OnInit,
} from "@angular/core";
import {
  MAT_DIALOG_DATA,
  MatDialogRef,
} from "@angular/material/dialog";
import {Store} from "@ngxs/store";
import {SharedAbstractContainer} from "@shared/components/containers/shared-abstract/shared-abstract.container";
import {ApplicationRoleEnum} from "@shared/enums/application-role.enum";

@Component({
  selector: "dlcm-admin-user-edit-role-current-user-dialog",
  templateUrl: "./admin-user-edit-role-current-user.dialog.html",
  styleUrls: ["./admin-user-edit-role-current-user.dialog.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class AdminUserEditRoleCurrentUserDialog extends SharedAbstractContainer implements OnInit {
  get applicationRoleEnum(): typeof ApplicationRoleEnum {
    return ApplicationRoleEnum;
  }

  constructor(protected store: Store,
              protected dialogRef: MatDialogRef<AdminUserEditRoleCurrentUserDialog>,
              @Inject(MAT_DIALOG_DATA) public data: AdminUserEditRoleCurrentUserDialogData) {
    super();
  }

  ngOnInit(): void {
    super.ngOnInit();
  }

  confirm(): void {
    this.dialogRef.close(true);
  }
}

export interface AdminUserEditRoleCurrentUserDialogData {
  removedRoles: string[];
  addedRoles: string[];
  newRolesAfterUpdate: string[];
  oldRolesBeforeUpdate: string[];
}
