import {
  ChangeDetectionStrategy,
  Component,
  Output,
} from "@angular/core";
import {SharedAbstractPresentational} from "@shared/components/presentationals/shared-abstract/shared-abstract.presentational";
import {RoutesEnum} from "@shared/enums/routes.enum";
import {
  BehaviorSubject,
  Observable,
} from "rxjs";
import {ObservableUtil} from "solidify-frontend";

@Component({
  selector: "dlcm-home-main-page-content",
  templateUrl: "./home-main-page-content.presentational.html",
  styleUrls: ["./home-main-page-content.presentational.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class HomeMainPageContentPresentational extends SharedAbstractPresentational {
  private readonly _navigateBS: BehaviorSubject<RoutesEnum> = new BehaviorSubject<RoutesEnum>(undefined);
  @Output("navigateChange")
  readonly navigateObs: Observable<RoutesEnum> = ObservableUtil.asObservable(this._navigateBS);

  goToDeposit(): void {
    this._navigateBS.next(RoutesEnum.deposit);
  }

  goToArchiveBrowsing(): void {
    this._navigateBS.next(RoutesEnum.homePageBrowsing);
  }
}
