import {Navigate} from "@ngxs/router-plugin";
import {Store} from "@ngxs/store";
import {RoutesEnum} from "@shared/enums/routes.enum";
import {Observable} from "rxjs";
import {
  isArray,
  isEmptyString,
  isNullOrUndefined,
} from "solidify-frontend";

export class HomeHelper {
  static SEARCH_QUERY_PARAM: string = "search";

  static navigateToSearch(store: Store, searchTerm?: string | undefined, url?: string | string[] | undefined): Observable<any> {
    if (isNullOrUndefined(url)) {
      url = RoutesEnum.homePage;
    }

    let queryParams = undefined;
    if (!isNullOrUndefined(searchTerm) && !isEmptyString(searchTerm)) {
      queryParams = {[this.SEARCH_QUERY_PARAM]: searchTerm};
    }
    return store.dispatch(new Navigate(isArray(url) ? url : [url], queryParams));
  }
}
