import {NgModule} from "@angular/core";
import {HomeBrowsingArchivePresentational} from "@app/features/home/components/presentationals/home-browsing-archive/home-browsing-archive.presentational";
import {HomeBrowsingOrgUnitPresentational} from "@app/features/home/components/presentationals/home-browsing-org-unit/home-browsing-org-unit.presentational";
import {HomeRssDetailPresentational} from "@app/features/home/components/presentationals/home-rss-detail/home-rss-detail.presentational";
import {HomeRssWrapperPresentational} from "@app/features/home/components/presentationals/home-rss-wrapper/home-rss-wrapper.presentational";
import {HomeSearchScopePresentational} from "@app/features/home/components/presentationals/home-search-scope/home-search-scope.presentational";
import {HomeTwitterWidgetPresentational} from "@app/features/home/components/presentationals/home-tweet-detail/home-twitter-widget.presentational";
import {HomeTwitterWrapperPresentational} from "@app/features/home/components/presentationals/home-tweet-wrapper/home-tweeter-wrapper.presentational";
import {HomeBrowsingListArchivesRoutable} from "@app/features/home/components/routables/home-browsing-list-archives/home-browsing-list-archives.routable";
import {HomeBrowsingRoutable} from "@app/features/home/components/routables/home-browsing/home-browsing.routable";
import {HomeDetailRoutable} from "@app/features/home/components/routables/home-detail/home-detail.routable";
import {HomeSearchRoutable} from "@app/features/home/components/routables/home-search/home-search.routable";
import {HomeRoutingModule} from "@app/features/home/home-routing.module";
import {TwitterService} from "@app/features/home/services/twitter.service";
import {HomeState} from "@app/features/home/stores/home.state";
import {HomeOrganizationalUnitArchiveState} from "@app/features/home/stores/organizational-unit/archive/home-organizational-unit-archive.state";
import {HomeOrganizationalUnitState} from "@app/features/home/stores/organizational-unit/home-organizational-unit.state";
import {SharedModule} from "@app/shared/shared.module";
import {ArchiveRestrictedRequestAccessDialog} from "@home/components/dialogs/archive-restricted-request-access/archive-restricted-request-access.dialog";
import {HomeArchiveDetailPresentational} from "@home/components/presentationals/home-archive-form/home-archive-detail.presentational";
import {HomeCarouselPresentational} from "@home/components/presentationals/home-carousel/home-carousel.presentational";
import {HomeMainButtonPresentational} from "@home/components/presentationals/home-main-button/home-main-button.presentational";
import {HomeMainPageContentPresentational} from "@home/components/presentationals/home-main-page-content/home-main-page-content.presentational";
import {HomePartnerImagePresentational} from "@home/components/presentationals/home-partner-image/home-partner-image.presentational";
import {HomePartnersPresentational} from "@home/components/presentationals/home-partners/home-partners.presentational";
import {HomeSearchBarPresentational} from "@home/components/presentationals/home-search-bar/home-search-bar.presentational";
import {HomeService} from "@home/services/home.service";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";

const routables = [
  HomeSearchRoutable,
  HomeDetailRoutable,
  HomeBrowsingRoutable,
  HomeBrowsingListArchivesRoutable,
];
const dialogs = [
  ArchiveRestrictedRequestAccessDialog,
];
const containers = [];
const presentationals = [
  HomeSearchBarPresentational,
  HomeArchiveDetailPresentational,
  HomeSearchScopePresentational,
  HomeTwitterWrapperPresentational,
  HomeTwitterWidgetPresentational,
  HomeRssWrapperPresentational,
  HomeRssDetailPresentational,
  HomeBrowsingOrgUnitPresentational,
  HomeBrowsingArchivePresentational,
  HomeMainPageContentPresentational,
  HomePartnersPresentational,
  HomePartnerImagePresentational,
  HomeCarouselPresentational,
  HomeMainButtonPresentational,
];
const services = [
  HomeService,
  TwitterService,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...presentationals,
    ...dialogs,
  ],
  imports: [
    SharedModule,
    HomeRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      HomeState,
      HomeOrganizationalUnitState,
      HomeOrganizationalUnitArchiveState,
    ]),
  ],
  exports: [
    ...routables,
  ],
  entryComponents: [
    ...dialogs,
  ],
  providers: [
    ...services,
  ],
})
export class HomeModule {
}
