import {Order} from "@models";
import {
  KeyValue,
  MARK_AS_TRANSLATABLE,
} from "solidify-frontend";

export class OrderStatusEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      {
        key: Order.StatusEnum.INERROR,
        value: MARK_AS_TRANSLATABLE("order.enum.status.inError"),
      },
      {
        key: Order.StatusEnum.INPREPARATION,
        value: MARK_AS_TRANSLATABLE("order.enum.status.inPreparation"),
      },
      {
        key: Order.StatusEnum.DOWNLOADING,
        value: MARK_AS_TRANSLATABLE("order.enum.status.downloading"),
      },
      {
        key: Order.StatusEnum.SUBMITTED,
        value: MARK_AS_TRANSLATABLE("order.enum.status.submitted"),
      },
      {
        key: Order.StatusEnum.INPROGRESS,
        value: MARK_AS_TRANSLATABLE("order.enum.status.inProgress"),
      },
      {
        key: Order.StatusEnum.READY,
        value: MARK_AS_TRANSLATABLE("order.enum.status.ready"),
      },
      {
        key: Order.StatusEnum.COMPLETED,
        value: MARK_AS_TRANSLATABLE("order.enum.status.completed"),
      },
      {
        key: Order.StatusEnum.INDISSEMINATIONPREPARATION,
        value: MARK_AS_TRANSLATABLE("order.enum.status.inDisseminationPreparation"),
      },
    ];
  }
}
