import {NgModule} from "@angular/core";
import {RouterModule} from "@angular/router";
import {OrderMyOrderDetailEditRoutable} from "@order/features/my-order/components/routables/my-order-detail-edit/order-my-order-detail-edit.routable";
import {OrderMyOrderListRoutable} from "@order/features/my-order/components/routables/my-order-list/order-my-order-list.routable";
import {OrderMyOrderState} from "@order/features/my-order/stores/order-my-order.state";
import {
  AppRoutesEnum,
  OrderRoutesEnum,
} from "@shared/enums/routes.enum";
import {DlcmRoutes} from "@shared/models/dlcm-route.model";
import {CanDeactivateGuard} from "@shared/services/can-deactivate-guard.service";
import {MARK_AS_TRANSLATABLE} from "solidify-frontend";

const routes: DlcmRoutes = [
  {
    path: AppRoutesEnum.root,
    component: OrderMyOrderListRoutable,
    data: {},
  },
  {
    path: OrderRoutesEnum.myOrderDetail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: OrderMyOrderDetailEditRoutable,
    data: {
      breadcrumbMemoizedSelector: OrderMyOrderState.currentTitle,
    },
    children: [
      {
        path: OrderRoutesEnum.myOrderEdit,
        data: {
          breadcrumb: MARK_AS_TRANSLATABLE("breadcrumb.order.myOrder.edit"),
        },
        canDeactivate: [CanDeactivateGuard],
      },
    ],
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class OrderMyOrderRoutingModule {
}
