import {NgModule} from "@angular/core";
import {RouterModule} from "@angular/router";
import {ContributorDetailEditRoutable} from "@app/features/preservation-space/contributor/components/routables/contributor-detail-edit/contributor-detail-edit.routable";
import {ContributorListRoutable} from "@app/features/preservation-space/contributor/components/routables/contributor-list/contributor-list.routable";
import {ContributorState} from "@app/features/preservation-space/contributor/stores/contributor.state";
import {DlcmRoutes} from "@app/shared/models/dlcm-route.model";
import {
  AppRoutesEnum,
  ContributorRoutesEnum,
} from "@shared/enums/routes.enum";

const routes: DlcmRoutes = [
  {
    path: AppRoutesEnum.root,
    component: ContributorListRoutable,
    data: {},
    children: [],
  },
  {
    path: ContributorRoutesEnum.detail + AppRoutesEnum.separator + AppRoutesEnum.paramId,
    component: ContributorDetailEditRoutable,
    data: {
      breadcrumbMemoizedSelector: ContributorState.currentTitle,
    },
  },
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class ContributorRoutingModule {
}
