import {NgModule} from "@angular/core";
import {ContributorFormPresentational} from "@app/features/preservation-space/contributor/components/presentationals/contributor-form/contributor-form.presentational";
import {ContributorDetailEditRoutable} from "@app/features/preservation-space/contributor/components/routables/contributor-detail-edit/contributor-detail-edit.routable";
import {ContributorListRoutable} from "@app/features/preservation-space/contributor/components/routables/contributor-list/contributor-list.routable";
import {ContributorRoutingModule} from "@app/features/preservation-space/contributor/contributor-routing.module";
import {ContributorDepositState} from "@app/features/preservation-space/contributor/stores/contributor-deposit/contributor-deposit.state";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";

const routables = [
  ContributorListRoutable,
  ContributorDetailEditRoutable,
];
const containers = [];
const dialogs = [];
const presentationals = [
  ContributorFormPresentational,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    ContributorRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      ContributorDepositState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class ContributorModule {
}
