import {ActivatedRoute} from "@angular/router";
import {NotificationModeEnum} from "@app/features/preservation-space/notification/enums/notification-mode.enum";
import {NotificationDlcm} from "@models";
import {PreservationSpaceRoutesEnum} from "@shared/enums/routes.enum";
import {isNotNullNorUndefined} from "solidify-frontend";

export class NotificationHelper {
  static readonly KEY_ORGUNIT_ID: keyof NotificationDlcm = "notifiedOrgUnit";
  static readonly KEY_ROLE_ID: string = "roleId";
  static readonly KEY_PERSON_ID: string = "personId";

  static getUrlQueryParam(orgUnitId: string): object {
    if (isNotNullNorUndefined(orgUnitId)) {
      return {
        [this.KEY_ORGUNIT_ID]: orgUnitId,
      };
    }
    return {};
  }

  static getMode(route: ActivatedRoute): NotificationModeEnum {
    const url = route.snapshot.parent.url.toString();
    let mode = NotificationModeEnum.inbox;
    if (url === PreservationSpaceRoutesEnum.notificationSent) {
      mode = NotificationModeEnum.sent;
    }
    return mode;
  }
}
