import {NgModule} from "@angular/core";
import {PreservationSpaceHomeRoutable} from "@app/features/preservation-space/components/routables/preservation-space-home/preservation-space-home.routable";
import {ContributorDepositState} from "@app/features/preservation-space/contributor/stores/contributor-deposit/contributor-deposit.state";
import {ContributorState} from "@app/features/preservation-space/contributor/stores/contributor.state";
import {PreservationSpaceNotificationState} from "@app/features/preservation-space/notification/stores/preservation-space-notification.state";
import {PreservationSpaceRoutingModule} from "@app/features/preservation-space/preservation-space-routing.module";
import {PreservationSpaceState} from "@app/features/preservation-space/stores/preservation-space.state";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";
import {PreservationSpaceNotificationStatusHistoryState} from "@app/features/preservation-space/notification/stores/status-history/preservation-space-notification-status-history.state";

const routables = [
  PreservationSpaceHomeRoutable,
];
const containers = [];
const dialogs = [];
const presentationals = [];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    PreservationSpaceRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      PreservationSpaceState,
      ContributorState,
      ContributorDepositState,
      PreservationSpaceNotificationState,
      PreservationSpaceNotificationStatusHistoryState
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class PreservationSpaceModule {
}
