import {Injectable} from "@angular/core";
import {
  ContributorState,
  ContributorStateModel,
} from "@app/features/preservation-space/contributor/stores/contributor.state";
import {
  PreservationSpaceNotificationState,
  PreservationSpaceNotificationStateModel,
} from "@app/features/preservation-space/notification/stores/preservation-space-notification.state";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";
import {
  State,
  Store,
} from "@ngxs/store";
import {
  BaseStateModel,
  defaultResourceStateInitValue,
} from "solidify-frontend";

export interface PreservationSpaceStateModel extends BaseStateModel {
  preservationSpace_contributor: ContributorStateModel;
  preservationSpace_notification: PreservationSpaceNotificationStateModel;
}

@Injectable()
@State<PreservationSpaceStateModel>({
  name: LocalStateEnum.preservationSpace,
  defaults: {
    ...defaultResourceStateInitValue(),
    preservationSpace_contributor: null,
    preservationSpace_notification: null,
  },
  children: [
    ContributorState,
    PreservationSpaceNotificationState,
  ],
})
export class PreservationSpaceState {
  constructor(protected store: Store) {
  }
}
