import {NgModule} from "@angular/core";
import {AipStatusHomeRoutable} from "@app/features/preservation/aip-status/components/routables/aip-status-home/aip-status-home.routable";
import {PreservationAipStatusRoutingModule} from "@app/features/preservation/aip-status/preservation-aip-status-routing.module";
import {PreservationAipStatusState} from "@app/features/preservation/aip-status/stores/preservation-aip-status.state";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";

const routables = [
  AipStatusHomeRoutable,
];
const containers = [];
const dialogs = [];
const presentationals = [];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    PreservationAipStatusRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      PreservationAipStatusState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class PreservationAipStatusModule {
}
