import {
  ModuleWithProviders,
  NgModule,
} from "@angular/core";
import {
  RouterModule,
  Routes,
} from "@angular/router";
import {AipFormPresentational} from "@app/features/preservation/aip/components/presentationals/aip-form/aip-form.presentational";
import {AipDetailEditRoutable} from "@app/features/preservation/aip/components/routables/aip-detail-edit/aip-detail-edit.routable";
import {AipHomeRoutable} from "@app/features/preservation/aip/components/routables/aip-home/aip-home.routable";
import {AipListRoutable} from "@app/features/preservation/aip/components/routables/aip-list/aip-list.routable";
import {PreservationAipState} from "@app/features/preservation/aip/stores/aip.state";
import {PreservationAipOrganizationalUnitState} from "@app/features/preservation/aip/stores/organizational-unit/aip-organizational-unit.state";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";
import {AipAipRoutable} from "@preservation/aip/components/routables/aip-aip/aip-aip.routable";
import {AipMetadataRoutable} from "@preservation/aip/components/routables/aip-metadata/aip-metadata.routable";
import {AipNotFoundRoutable} from "@preservation/aip/components/routables/aip-not-found/aip-not-found.routable";
import {AipStoragionRootRoutable} from "@preservation/aip/components/routables/aip-storagion-root/aip-storagion-root.routable";
import {AipTabsRoutable} from "@preservation/aip/components/routables/aip-tabs/aip-tabs.routable";
import {PreservationAipAipState} from "@preservation/aip/stores/aip-aip/aip-aip.state";
import {PreservationAipAipStatusHistoryState} from "@preservation/aip/stores/aip-aip/status-history/aip-aip-status-history.state";
import {PreservationAipStatusHistoryState} from "@preservation/aip/stores/status-history/aip-status-history.state";
import {SharedModule} from "@shared/shared.module";

const routables = [
  AipHomeRoutable,
  AipTabsRoutable,
  AipListRoutable,
  AipDetailEditRoutable,
  AipStoragionRootRoutable,
  AipMetadataRoutable,
  AipAipRoutable,
  AipNotFoundRoutable,
];
const containers = [];
const dialogs = [];
const presentationals = [
  AipFormPresentational,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    RouterModule,
    SharedModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      PreservationAipState,
      PreservationAipOrganizationalUnitState,
      PreservationAipAipState,
      PreservationAipStatusHistoryState,
      PreservationAipAipStatusHistoryState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
    SharedModule,
    RouterModule,
  ],
  providers: [],
})
export class AipSharedModule {
  static forChild(routes: Routes): ModuleWithProviders<AipSharedModule> {
    return {
      ngModule: AipSharedModule,
      providers: RouterModule.forChild(routes).providers,
    };
  }
}
