import {NgModule} from "@angular/core";
import {DipFormPresentational} from "@app/features/preservation/dip/components/presentationals/dip-form/dip-form.presentational";
import {DipFileRoutable} from "@app/features/preservation/dip/components/routables/dip-file/dip-file.routable";
import {DipListRoutable} from "@app/features/preservation/dip/components/routables/dip-list/dip-list.routable";
import {DipMetadataRoutable} from "@app/features/preservation/dip/components/routables/dip-metadata/dip-metadata.routable";
import {DipDataFileState} from "@app/features/preservation/dip/stores/data-file/dip-data-file.state";
import {DipDataFileStatusHistoryState} from "@app/features/preservation/dip/stores/data-file/status-history/dip-data-file-status-history.state";
import {DipState} from "@app/features/preservation/dip/stores/dip.state";
import {DipStatusHistoryState} from "@app/features/preservation/dip/stores/status-history/dip-status-history.state";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";
import {DipRoutingModule} from "@preservation/dip/dip-routing.module";
import {DipDetailEditRoutable} from "./components/routables/dip-detail-edit/dip-detail-edit.routable";

const routables = [
  DipListRoutable,
  DipDetailEditRoutable,
  DipFileRoutable,
  DipMetadataRoutable,
];
const containers = [];
const dialogs = [];
const presentationals = [
  DipFormPresentational,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    DipRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      DipState,
      DipDataFileState,
      DipStatusHistoryState,
      DipDataFileStatusHistoryState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class DipModule {
}
