import {ActivatedRoute} from "@angular/router";
import {DipTabEnum} from "@preservation/dip/enums/dip-tab.enum";
import {PreservationPlanningRoutesEnum} from "@shared/enums/routes.enum";

export class DipHelper {
  static getTabRouteSelected(route: ActivatedRoute): PreservationPlanningRoutesEnum | undefined {
    const children = route.snapshot.children;
    if (children.length > 0 && children[0].url.length > 0) {
      const mode = children[0].url[0].path;
      return mode as PreservationPlanningRoutesEnum;
    }
    return undefined;
  }

  static getTabSelectedIndexWithRoute(tabRouteSelected: PreservationPlanningRoutesEnum): DipTabEnum | undefined {
    if (tabRouteSelected === PreservationPlanningRoutesEnum.dipMetadata) {
      return DipTabEnum.metadata;
    }
    if (tabRouteSelected === PreservationPlanningRoutesEnum.dipFiles) {
      return DipTabEnum.file;
    }
    return undefined;
  }

  static getTabRouteSelectedWithTabIndex(tabIndexSelected: DipTabEnum): PreservationPlanningRoutesEnum | undefined {
    if (tabIndexSelected === DipTabEnum.metadata) {
      return PreservationPlanningRoutesEnum.dipMetadata;
    }
    if (tabIndexSelected === DipTabEnum.file) {
      return PreservationPlanningRoutesEnum.dipFiles;
    }
    return undefined;
  }
}
