import {Injectable} from "@angular/core";
import {preservationDipDataFileStatusHistoryNamespace} from "@app/features/preservation/dip/stores/data-file/status-history/dip-data-file-status-history.action";
import {AccessResourceApiEnum} from "@app/shared/enums/api.enum";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";

import {
  Actions,
  State,
  Store,
} from "@ngxs/store";
import {DipDataFile} from "@preservation/dip/models/dip-data-file.model";
import {
  defaultStatusHistoryInitValue,
  StatusHistoryState,
  StatusHistoryStateModel,
} from "@shared/stores/status-history/status-history.state";
import {
  ApiService,
  NotificationService,
} from "solidify-frontend";

export interface DipDataFileStatusHistoryStateModel extends StatusHistoryStateModel<DipDataFile> {
}

@Injectable()
@State<DipDataFileStatusHistoryStateModel>({
  name: LocalStateEnum.preservation_dip_dataFile_statusHistory,
  defaults: {
    ...defaultStatusHistoryInitValue(),
  },
})
export class DipDataFileStatusHistoryState extends StatusHistoryState<DipDataFileStatusHistoryStateModel, DipDataFile> {

  constructor(protected apiService: ApiService,
              protected store: Store,
              protected notificationService: NotificationService,
              protected actions$: Actions) {
    super(apiService, store, notificationService, actions$, {
      nameSpace: preservationDipDataFileStatusHistoryNamespace,
    });
  }

  protected get _urlResource(): string {
    return AccessResourceApiEnum.dipDataFile;
  }
}
