import {Injectable} from "@angular/core";
import {preservationDipStatusHistoryNamespace} from "@app/features/preservation/dip/stores/status-history/dip-status-history.action";
import {AccessResourceApiEnum} from "@app/shared/enums/api.enum";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";
import {Dip} from "@models";

import {
  Actions,
  State,
  Store,
} from "@ngxs/store";
import {
  defaultStatusHistoryInitValue,
  StatusHistoryState,
  StatusHistoryStateModel,
} from "@shared/stores/status-history/status-history.state";
import {
  ApiService,
  NotificationService,
} from "solidify-frontend";

export interface DipStatusHistoryStateModel extends StatusHistoryStateModel<Dip> {
}

@Injectable()
@State<DipStatusHistoryStateModel>({
  name: LocalStateEnum.preservation_dip_statusHistory,
  defaults: {
    ...defaultStatusHistoryInitValue(),
  },
})
export class DipStatusHistoryState extends StatusHistoryState<DipStatusHistoryStateModel, Dip> {

  constructor(protected apiService: ApiService,
              protected store: Store,
              protected notificationService: NotificationService,
              protected actions$: Actions) {
    super(apiService, store, notificationService, actions$, {
      nameSpace: preservationDipStatusHistoryNamespace,
    });
  }

  protected get _urlResource(): string {
    return AccessResourceApiEnum.dip;
  }
}
