import {
  ChangeDetectorRef,
  Component,
  ViewChild,
} from "@angular/core";
import {preservationJobActionNameSpace} from "@app/features/preservation/job/stores/preservation-job.action";
import {
  PreservationJobState,
  PreservationJobStateModel,
} from "@app/features/preservation/job/stores/preservation-job.state";
import {PreservationJob} from "@models";
import {
  Actions,
  Select,
  Store,
} from "@ngxs/store";
import {SharedAbstractFormPresentational} from "@shared/components/presentationals/shared-abstract-form/shared-abstract-form.presentational";
import {SharedAbstractCreateRoutable} from "@shared/components/routables/shared-abstract-create/shared-abstract-create.routable";
import {LocalStateEnum} from "@shared/enums/local-state.enum";
import {Observable} from "rxjs";

@Component({
  selector: "dlcm-job-create-routable",
  templateUrl: "./job-create.routable.html",
  styleUrls: ["../../../../../../shared/components/routables/shared-abstract-create/shared-abstract-create.routable.scss"],
})
export class JobCreateRoutable extends SharedAbstractCreateRoutable<PreservationJob, PreservationJobStateModel> {
  @Select(PreservationJobState.isLoadingWithDependency) isLoadingWithDependencyObs: Observable<boolean>;
  @Select(PreservationJobState.isReadyToBeDisplayedInCreateMode) isReadyToBeDisplayedInCreateModeObs: Observable<boolean>;

  @ViewChild("formPresentational")
  readonly formPresentational: SharedAbstractFormPresentational<PreservationJob>;

  constructor(protected readonly _store: Store,
              protected readonly _actions$: Actions,
              protected readonly _changeDetector: ChangeDetectorRef) {
    super(_store, _actions$, _changeDetector, LocalStateEnum.preservation_job, preservationJobActionNameSpace, LocalStateEnum.preservation);
  }
}
