import {PreservationJob} from "@models";
import {
  KeyValue,
  MARK_AS_TRANSLATABLE,
} from "solidify-frontend";

export class JobHelper {

  static getRecurrenceEnum(): KeyValue[] {
    return [
      {
        key: PreservationJob.JobRecurrenceEnum.DAILY,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobRecurrenceEnum.daily"),
      },
      {
        key: PreservationJob.JobRecurrenceEnum.WEEKLY,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobRecurrenceEnum.weekly"),
      },
      {
        key: PreservationJob.JobRecurrenceEnum.MONTHLY,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobRecurrenceEnum.monthly"),
      },
      {
        key: PreservationJob.JobRecurrenceEnum.YEARLY,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobRecurrenceEnum.yearly"),
      },
      {
        key: PreservationJob.JobRecurrenceEnum.ONCE,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobRecurrenceEnum.once"),
      },
    ];
  }

  static getTypeEnum(): KeyValue[] {
    return [
      {
        key: PreservationJob.JobTypeEnum.CLEANSUBMISSION,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobTypeEnum.cleanSubmission"),
      },
      {
        key: PreservationJob.JobTypeEnum.FIXITY,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobTypeEnum.fixity"),
      },
      {
        key: PreservationJob.JobTypeEnum.MIGRATION,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobTypeEnum.migration"),
      },
      {
        key: PreservationJob.JobTypeEnum.PURGESUBMISSIONTEMPFILES,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobTypeEnum.purgeSubmissionTempFiles"),
      },
      {
        key: PreservationJob.JobTypeEnum.REBUILDREGISTRY,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobTypeEnum.rebuildRegistry"),
      },
      {
        key: PreservationJob.JobTypeEnum.REINDEX,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobTypeEnum.reindex"),
      },
      {
        key: PreservationJob.JobTypeEnum.RELOAD,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobTypeEnum.reload"),
      },
      {
        key: PreservationJob.JobTypeEnum.REPLICATION,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobTypeEnum.replication"),
      },
      {
        key: PreservationJob.JobTypeEnum.REPLICATIONCHECK,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobTypeEnum.replicationCheck"),
      },
      {
        key: PreservationJob.JobTypeEnum.ARCHIVECHECK,
        value: MARK_AS_TRANSLATABLE("preservation.job.jobTypeEnum.archiveCheck"),
      },
    ];
  }

  static getWeekDays(): KeyValue[] {
    return [
      {
        key: "1",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.weekday.monday"),
      },
      {
        key: "2",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.weekday.tuesday"),
      },
      {
        key: "3",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.weekday.wednesday"),
      },
      {
        key: "4",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.weekday.thursday"),
      },
      {
        key: "5",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.weekday.friday"),
      },
      {
        key: "6",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.weekday.saturday"),
      },
      {
        key: "7",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.weekday.sunday"),
      },
    ];
  }

  static getMonths(): KeyValue[] {
    return [
      {
        key: "1",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.january"),
      },
      {
        key: "2",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.february"),
      },
      {
        key: "3",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.march"),
      },
      {
        key: "4",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.april"),
      },
      {
        key: "5",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.may"),
      },
      {
        key: "6",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.june"),
      },
      {
        key: "7",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.july"),
      },
      {
        key: "8",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.august"),
      },
      {
        key: "9",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.september"),
      },
      {
        key: "10",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.october"),
      },
      {
        key: "11",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.november"),
      },
      {
        key: "12",
        value: MARK_AS_TRANSLATABLE("preservation.job.scheduling.month.december"),
      },
    ];
  }
}
