import {NgModule} from "@angular/core";
import {JobExecutionListContainer} from "@app/features/preservation/job/components/containers/job-execution-list/job-execution-list.container";
import {JobDeleteDialog} from "@app/features/preservation/job/components/dialogs/job-delete/job-delete.dialog";
import {JobFormPresentational} from "@app/features/preservation/job/components/presentationals/job-form/job-form.presentational";
import {JobCreateRoutable} from "@app/features/preservation/job/components/routables/job-create/job-create.routable";
import {JobDetailEditRoutable} from "@app/features/preservation/job/components/routables/job-detail-edit/job-detail-edit.routable";
import {JobListRoutable} from "@app/features/preservation/job/components/routables/job-list/job-list.routable";
import {PreservationJobRoutingModule} from "@app/features/preservation/job/preservation-job-routing.module";
import {PreservationJobExecutionState} from "@app/features/preservation/job/stores/preservation-job-execution/preservation-job-execution.state";
import {PreservationJobState} from "@app/features/preservation/job/stores/preservation-job.state";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";
import {JobExecutionDetailDialog} from "@preservation/job/components/dialogs/job-execution-detail/job-execution-detail.dialog";
import {JobReportDetailErrorMessageDialog} from "@preservation/job/components/dialogs/job-report-detail-error-message/job-report-detail-error-message.dialog";
import {JobReportDetailDialog} from "@preservation/job/components/dialogs/job-report-detail/job-report-detail.dialog";
import {JobExecutionFormPresentational} from "@preservation/job/components/presentationals/job-execution-form/job-execution-form.presentational";
import {JobExecutionDetailRoutable} from "@preservation/job/components/routables/job-execution-detail/job-execution-detail.routable";
import {PreservationJobExecutionReportState} from "@preservation/job/stores/preservation-job-execution/preservation-job-execution-report/preservation-job-execution-report.state";

const routables = [
  JobListRoutable,
  JobDetailEditRoutable,
  JobCreateRoutable,
  JobExecutionDetailRoutable,
];
const containers = [
  JobExecutionListContainer,
];
const dialogs = [
  JobDeleteDialog,
  JobReportDetailDialog,
  JobExecutionDetailDialog,
  JobReportDetailErrorMessageDialog,
];
const presentationals = [
  JobFormPresentational,
  JobExecutionFormPresentational,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    PreservationJobRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      PreservationJobState,
      PreservationJobExecutionState,
      PreservationJobExecutionReportState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class PreservationJobModule {
}
