import {NgModule} from "@angular/core";
import {MonitoringServicePresentational} from "@app/features/preservation/monitoring/components/presentationals/monitoring-service/monitoring-service.presentational";
import {MonitoringHomeRoutable} from "@app/features/preservation/monitoring/components/routables/monitoring-home/monitoring-home.routable";
import {PreservationMonitoringRoutingModule} from "@app/features/preservation/monitoring/preservation-monitoring-routing.module";
import {PreservationMonitoringState} from "@app/features/preservation/monitoring/stores/preservation-monitoring.state";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";
import {MonitoringWebServiceDialog} from "@preservation/monitoring/components/dialogs/monitoring-web-service/monitoring-web-service.dialog";
import {PreservationMonitoringWebServiceState} from "@preservation/monitoring/stores/web-service/preservation-monitoring-web-service.state";

const routables = [
  MonitoringHomeRoutable,
];
const containers = [];
const dialogs = [
  MonitoringWebServiceDialog,
];
const presentationals = [
  MonitoringServicePresentational,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    PreservationMonitoringRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      PreservationMonitoringState,
      PreservationMonitoringWebServiceState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class PreservationMonitoringModule {
}
