import {NgModule} from "@angular/core";
import {PreservationAipStatusState} from "@app/features/preservation/aip-status/stores/preservation-aip-status.state";
import {PreservationAipState} from "@app/features/preservation/aip/stores/aip.state";
import {PreservationAipOrganizationalUnitState} from "@app/features/preservation/aip/stores/organizational-unit/aip-organizational-unit.state";
import {PreservationHomeRoutable} from "@app/features/preservation/components/routables/preservation-home/preservation-home.routable";
import {PreservationJobExecutionState} from "@app/features/preservation/job/stores/preservation-job-execution/preservation-job-execution.state";
import {PreservationJobState} from "@app/features/preservation/job/stores/preservation-job.state";
import {PreservationMonitoringState} from "@app/features/preservation/monitoring/stores/preservation-monitoring.state";
import {PreservationRoutingModule} from "@app/features/preservation/preservation-routing.module";
import {PreservationState} from "@app/features/preservation/stores/preservation.state";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";
import {PreservationAipAipState} from "@preservation/aip/stores/aip-aip/aip-aip.state";
import {PreservationAipAipStatusHistoryState} from "@preservation/aip/stores/aip-aip/status-history/aip-aip-status-history.state";
import {PreservationAipStatusHistoryState} from "@preservation/aip/stores/status-history/aip-status-history.state";
import {DipDataFileState} from "@preservation/dip/stores/data-file/dip-data-file.state";
import {DipDataFileStatusHistoryState} from "@preservation/dip/stores/data-file/status-history/dip-data-file-status-history.state";
import {DipState} from "@preservation/dip/stores/dip.state";
import {DipStatusHistoryState} from "@preservation/dip/stores/status-history/dip-status-history.state";
import {PreservationJobExecutionReportState} from "@preservation/job/stores/preservation-job-execution/preservation-job-execution-report/preservation-job-execution-report.state";
import {PreservationMonitoringWebServiceState} from "@preservation/monitoring/stores/web-service/preservation-monitoring-web-service.state";
import {SipDataFileState} from "@preservation/sip/stores/data-file/sip-data-file.state";
import {SipDataFileStatusHistoryState} from "@preservation/sip/stores/data-file/status-history/sip-data-file-status-history.state";
import {SipState} from "@preservation/sip/stores/sip.state";
import {SipStatusHistoryState} from "@preservation/sip/stores/status-history/sip-status-history.state";

const routables = [
  PreservationHomeRoutable,
];
const containers = [];
const dialogs = [];
const presentationals = [];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    PreservationRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      PreservationState,
      PreservationMonitoringState,
      PreservationMonitoringWebServiceState,
      PreservationAipStatusState,
      PreservationJobState,
      PreservationJobExecutionState,
      PreservationJobExecutionReportState,
      SipState,
      SipDataFileState,
      SipStatusHistoryState,
      SipDataFileStatusHistoryState,
      DipState,
      DipDataFileState,
      DipStatusHistoryState,
      DipDataFileStatusHistoryState,
      PreservationAipState,
      PreservationAipOrganizationalUnitState,
      PreservationAipAipState,
      PreservationAipStatusHistoryState,
      PreservationAipAipStatusHistoryState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class PreservationModule {
}
