import {ActivatedRoute} from "@angular/router";
import {SipTabEnum} from "@preservation/sip/enums/sip-tab.enum";
import {PreservationPlanningRoutesEnum} from "@shared/enums/routes.enum";

export class SipHelper {
  static getTabRouteSelected(route: ActivatedRoute): PreservationPlanningRoutesEnum | undefined {
    const children = route.snapshot.children;
    if (children.length > 0 && children[0].url.length > 0) {
      const mode = children[0].url[0].path;
      return mode as PreservationPlanningRoutesEnum;
    }
    return undefined;
  }

  static getTabSelectedIndexWithRoute(tabRouteSelected: PreservationPlanningRoutesEnum): SipTabEnum | undefined {
    if (tabRouteSelected === PreservationPlanningRoutesEnum.sipMetadata) {
      return SipTabEnum.metadata;
    }
    if (tabRouteSelected === PreservationPlanningRoutesEnum.sipFiles) {
      return SipTabEnum.file;
    }
    return undefined;
  }

  static getTabRouteSelectedWithTabIndex(tabIndexSelected: SipTabEnum): PreservationPlanningRoutesEnum | undefined {
    if (tabIndexSelected === SipTabEnum.metadata) {
      return PreservationPlanningRoutesEnum.sipMetadata;
    }
    if (tabIndexSelected === SipTabEnum.file) {
      return PreservationPlanningRoutesEnum.sipFiles;
    }
    return undefined;
  }
}
