import {NgModule} from "@angular/core";
import {SipFormPresentational} from "@app/features/preservation/sip/components/presentationals/sip-form/sip-form.presentational";
import {SipFileRoutable} from "@app/features/preservation/sip/components/routables/sip-file/sip-file.routable";
import {SipListRoutable} from "@app/features/preservation/sip/components/routables/sip-list/sip-list.routable";
import {SipMetadataRoutable} from "@app/features/preservation/sip/components/routables/sip-metadata/sip-metadata.routable";
import {SipDataFileState} from "@app/features/preservation/sip/stores/data-file/sip-data-file.state";
import {SipDataFileStatusHistoryState} from "@app/features/preservation/sip/stores/data-file/status-history/sip-data-file-status-history.state";
import {SipState} from "@app/features/preservation/sip/stores/sip.state";
import {SipStatusHistoryState} from "@app/features/preservation/sip/stores/status-history/sip-status-history.state";
import {SharedModule} from "@app/shared/shared.module";
import {TranslateModule} from "@ngx-translate/core";
import {NgxsModule} from "@ngxs/store";
import {SipRoutingModule} from "@preservation/sip/sip-routing.module";
import {SipDetailEditRoutable} from "./components/routables/sip-detail-edit/sip-detail-edit.routable";

const routables = [
  SipListRoutable,
  SipDetailEditRoutable,
  SipFileRoutable,
  SipMetadataRoutable,
];
const containers = [];
const dialogs = [];
const presentationals = [
  SipFormPresentational,
];

@NgModule({
  declarations: [
    ...routables,
    ...containers,
    ...dialogs,
    ...presentationals,
  ],
  imports: [
    SharedModule,
    SipRoutingModule,
    TranslateModule.forChild({}),
    NgxsModule.forFeature([
      SipState,
      SipDataFileState,
      SipStatusHistoryState,
      SipDataFileStatusHistoryState,
    ]),
  ],
  entryComponents: [
    ...dialogs,
  ],
  exports: [
    ...routables,
  ],
  providers: [],
})
export class SipModule {
}
