import {Injectable} from "@angular/core";
import {preservationSipDataFileStatusHistoryNamespace} from "@app/features/preservation/sip/stores/data-file/status-history/sip-data-file-status-history.action";
import {IngestResourceApiEnum} from "@app/shared/enums/api.enum";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";

import {
  Actions,
  State,
  Store,
} from "@ngxs/store";
import {SipDataFile} from "@preservation/sip/models/sip-data-file.model";
import {
  defaultStatusHistoryInitValue,
  StatusHistoryState,
  StatusHistoryStateModel,
} from "@shared/stores/status-history/status-history.state";
import {
  ApiService,
  NotificationService,
} from "solidify-frontend";

export interface SipDataFileStatusHistoryStateModel extends StatusHistoryStateModel<SipDataFile> {
}

@Injectable()
@State<SipDataFileStatusHistoryStateModel>({
  name: LocalStateEnum.preservation_sip_dataFile_statusHistory,
  defaults: {
    ...defaultStatusHistoryInitValue(),
  },
})
export class SipDataFileStatusHistoryState extends StatusHistoryState<SipDataFileStatusHistoryStateModel, SipDataFile> {

  constructor(protected apiService: ApiService,
              protected store: Store,
              protected notificationService: NotificationService,
              protected actions$: Actions) {
    super(apiService, store, notificationService, actions$, {
      nameSpace: preservationSipDataFileStatusHistoryNamespace,
    });
  }

  protected get _urlResource(): string {
    return IngestResourceApiEnum.sipDataFile;
  }
}
