import {Injectable} from "@angular/core";
import {preservationSipStatusHistoryNamespace} from "@app/features/preservation/sip/stores/status-history/sip-status-history.action";
import {IngestResourceApiEnum} from "@app/shared/enums/api.enum";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";
import {Sip} from "@models";

import {
  Actions,
  State,
  Store,
} from "@ngxs/store";
import {
  defaultStatusHistoryInitValue,
  StatusHistoryState,
  StatusHistoryStateModel,
} from "@shared/stores/status-history/status-history.state";
import {
  ApiService,
  NotificationService,
} from "solidify-frontend";

export interface SipStatusHistoryStateModel extends StatusHistoryStateModel<Sip> {
}

@Injectable()
@State<SipStatusHistoryStateModel>({
  name: LocalStateEnum.preservation_sip_statusHistory,
  defaults: {
    ...defaultStatusHistoryInitValue(),
  },
})
export class SipStatusHistoryState extends StatusHistoryState<SipStatusHistoryStateModel, Sip> {

  constructor(protected apiService: ApiService,
              protected store: Store,
              protected notificationService: NotificationService,
              protected actions$: Actions) {
    super(apiService, store, notificationService, actions$, {
      nameSpace: preservationSipStatusHistoryNamespace,
    });
  }

  protected get _urlResource(): string {
    return IngestResourceApiEnum.sip;
  }
}
