import {Injectable} from "@angular/core";
import {
  PreservationAipStatusState,
  PreservationAipStatusStateModel,
} from "@app/features/preservation/aip-status/stores/preservation-aip-status.state";
import {
  PreservationAipState,
  PreservationAipStateModel,
} from "@app/features/preservation/aip/stores/aip.state";
import {
  PreservationJobState,
  PreservationJobStateModel,
} from "@app/features/preservation/job/stores/preservation-job.state";
import {
  PreservationMonitoringState,
  PreservationMonitoringStateModel,
} from "@app/features/preservation/monitoring/stores/preservation-monitoring.state";
import {LocalStateEnum} from "@app/shared/enums/local-state.enum";
import {
  State,
  Store,
} from "@ngxs/store";
import {
  DipState,
  DipStateModel,
} from "@preservation/dip/stores/dip.state";
import {
  SipState,
  SipStateModel,
} from "@preservation/sip/stores/sip.state";
import {BaseStateModel} from "solidify-frontend";

export interface PreservationStateModel extends BaseStateModel {
  preservation_monitoring: PreservationMonitoringStateModel | undefined;
  preservation_job: PreservationJobStateModel | undefined;
  preservation_aipStatus: PreservationAipStatusStateModel | undefined;
  preservation_sip: SipStateModel | undefined;
  preservation_dip: DipStateModel | undefined;
  preservation_aip: PreservationAipStateModel | undefined;
}

@Injectable()
@State<PreservationStateModel>({
  name: LocalStateEnum.preservation,
  defaults: {
    isLoadingCounter: 0,
    preservation_monitoring: undefined,
    preservation_job: undefined,
    preservation_aipStatus: undefined,
    preservation_sip: undefined,
    preservation_dip: undefined,
    preservation_aip: undefined,
  },
  children: [
    PreservationMonitoringState,
    PreservationJobState,
    PreservationAipStatusState,
    SipState,
    DipState,
    PreservationAipState,
  ],
})
export class PreservationState {
  constructor(protected store: Store) {
  }
}
