import {Tool} from "@deposit/models/tool.model";
import {AccessOrganizationalUnit as AccessOrganizationalUnitPartial} from "../generated-api/model/access-organizational-unit.partial.model";
import {Access as AccessPartial} from "../generated-api/model/access.partial.model";
import {Admin as AdminPartial} from "../generated-api/model/admin.partial.model";
import {AipChecksumCheck as AipChecksumCheckPartial} from "../generated-api/model/aip-checksum-check.partial.model";
import {AipFileFormat as AipFileFormatPartial} from "../generated-api/model/aip-file-format.partial.model";
import {AipInfoEmbargo as AipInfoEmbargoPartial} from "../generated-api/model/aip-info-embargo.partial.model";
import {AipInfo as AipInfoPartial} from "../generated-api/model/aip-info.partial.model";
import {AipVirusCheck as AipVirusCheckPartial} from "../generated-api/model/aip-virus-check.partial.model";
import {Aip as AipPartial} from "../generated-api/model/aip.partial.model";
import {ApplicationRole as ApplicationRolePartial} from "../generated-api/model/application-role.partial.model";
import {Application as ApplicationPartial} from "../generated-api/model/application.partial.model";
import {ArchivalStorage as ArchivalStoragePartial} from "../generated-api/model/archival-storage.partial.model";
import {ChangeInfo as ChangeInfoPartial} from "../generated-api/model/change-info.partial.model";
import {Collection as CollectionPartial} from "../generated-api/model/collection.partial.model";
import {Contributor as ContributorPartial} from "../generated-api/model/contributor.partial.model";
import {DataMgmt as DataMgmtPartial} from "../generated-api/model/data-mgmt.partial.model";
import {Deposit as DepositPartial} from "../generated-api/model/deposit.partial.model";
import {Dip as DipPartial} from "../generated-api/model/dip.partial.model";
import {DisseminationPolicy as DisseminationPolicyPartial} from "../generated-api/model/dissemination-policy.partial.model";
import {FundingAgency as FundingAgencyPartial} from "../generated-api/model/funding-agency.partial.model";
import {Ingest as IngestPartial} from "../generated-api/model/ingest.partial.model";
import {Institution as InstitutionPartial} from "../generated-api/model/institution.partial.model";
import {Language as LanguagePartial} from "../generated-api/model/language.partial.model";
import {License as LicensePartial} from "../generated-api/model/license.partial.model";
import {MetadataType as MetadataTypePartial} from "../generated-api/model/metadata-type.partial.model";
import {OaiSet as OaiSetPartial} from "../generated-api/model/oai-set.partial.model";
import {Oauth2Client as Oauth2ClientPartial} from "../generated-api/model/oauth2-client.partial.model";
import {Order as OrderPartial} from "../generated-api/model/order.partial.model";
import {OrganizationalUnit as OrganizationalUnitPartial} from "../generated-api/model/organizational-unit.partial.model";
import {Page as PagePartial} from "../generated-api/model/page.partial.model";
import {Person as PersonPartial} from "../generated-api/model/person.partial.model";
import {Preingest as PreingestPartial} from "../generated-api/model/preingest.partial.model";
import {PreservationJobScheduling as PreservationJobSchedulingPartial} from "../generated-api/model/preservation-job-scheduling.partial.model";
import {PreservationJob as PreservationJobPartial} from "../generated-api/model/preservation-job.partial.model";
import {PreservationPlanning as PreservationPlanningPartial} from "../generated-api/model/preservation-planning.partial.model";
import {PreservationPolicy as PreservationPolicyPartial} from "../generated-api/model/preservation-policy.partial.model";
import {ResearchDomain as ResearchDomainPartial} from "../generated-api/model/research-domain.partial.model";
import {ResourceSrv as ResourceSrvPartial} from "../generated-api/model/resource-srv.partial.model";
import {Role as RolePartial} from "../generated-api/model/role.partial.model";
import {Sip as SipPartial} from "../generated-api/model/sip.partial.model";
import {SubmissionAgreement as SubmissionAgreementPartial} from "../generated-api/model/submission-agreement.partial.model";
import {SubmissionPolicy as SubmissionPolicyPartial} from "../generated-api/model/submission-policy.partial.model";
import {User as UserPartial} from "../generated-api/model/user.partial.model";

export interface AccessOrganizationalUnit extends AccessOrganizationalUnitPartial {
}

export interface Access extends AccessPartial {
}

export interface Admin extends AdminPartial {
}

export interface AipChecksumCheck extends AipChecksumCheckPartial {
  details?: string;
  tool?: Tool;
}

export interface AipFileFormat extends AipFileFormatPartial {
  tool?: Tool;
}

export interface AipInfoEmbargo extends AipInfoEmbargoPartial {
}

export interface AipInfo extends AipInfoPartial {
}

export interface Aip extends AipPartial {
  organizationalUnit?: string;
  fileFormat?: AipFileFormat;
  virusCheck?: AipChecksumCheck;
}

export namespace Aip {
  export type AipContainerEnum = AipPartial.ArchiveContainerEnum;
  export const AipContainerEnum = AipPartial.ArchiveContainerEnum;
}

export interface AipVirusCheck extends AipVirusCheckPartial {
}

export interface Application extends ApplicationPartial {
}

export interface ApplicationRole extends ApplicationRolePartial {
}

export interface ArchivalStorage extends ArchivalStoragePartial {
}

export interface ChangeInfo extends ChangeInfoPartial {
}

export interface Collection extends CollectionPartial {
}

export interface Contributor extends ContributorPartial {
}

export namespace FormDescriptionType {
  // tslint:disable-next-line:no-shadowed-variable
  export type FormDescriptionTypeEnum = "FORMLY";
  // tslint:disable-next-line:no-shadowed-variable
  export const FormDescriptionTypeEnum = {
    FORMLY: "FORMLY" as FormDescriptionTypeEnum,
  };
}

export interface AdditionalFieldsForm {
  resId?: string;
  type: FormDescriptionType.FormDescriptionTypeEnum;
  name: string;
  description: string;
  creation?: ChangeInfo;
  lastUpdate?: ChangeInfo;
}

export interface DataMgmt extends DataMgmtPartial {
}

export interface Deposit extends DepositPartial {
  organizationalUnit?: OrganizationalUnit;
  language?: Language;
  preservationPolicy?: PreservationPolicy;
  submissionPolicy?: SubmissionPolicy;
  collectionBegin?: any;
  collectionEnd?: any;
  additionalFieldsValues?: string;
}

export namespace Deposit {
  export type AccessEnum = DepositPartial.AccessEnum;
  export const AccessEnum = DepositPartial.AccessEnum;
  export type StatusEnum = DepositPartial.StatusEnum;
  export const StatusEnum = DepositPartial.StatusEnum;
}

export interface Dip extends DipPartial {
}

export interface DisseminationPolicy extends DisseminationPolicyPartial {
}

export namespace DisseminationPolicy {
  export type TypeEnum = DisseminationPolicyPartial.TypeEnum;
  export const TypeEnum = DisseminationPolicyPartial.TypeEnum;
}

export interface FundingAgency extends FundingAgencyPartial {
}

export interface Ingest extends IngestPartial {
}

export interface Institution extends InstitutionPartial {
}

export interface Language extends LanguagePartial {
}

export interface License extends LicensePartial {
}

export namespace License {
  export type OdConformanceEnum = LicensePartial.OdConformanceEnum;
  export const OdConformanceEnum = LicensePartial.OdConformanceEnum;
  export type OsdConformanceEnum = LicensePartial.OsdConformanceEnum;
  export const OsdConformanceEnum = LicensePartial.OsdConformanceEnum;
  export type StatusEnum = LicensePartial.StatusEnum;
  export const StatusEnum = LicensePartial.StatusEnum;
}

export interface MetadataType extends MetadataTypePartial {
}

export namespace MetadataType {
  export type MetadataFormatEnum = MetadataTypePartial.MetadataFormatEnum;
  export const MetadataFormatEnum = MetadataTypePartial.MetadataFormatEnum;
}

export interface NotificationDlcm {
  resId?: string;
  specification?: object;
  notificationType?: NotificationType.NotificationTypeEnum;
  notificationStatus?: NotificationStatus.NotificationStatusEnum;
  managedBy?: object;
  notifiedOrgUnit?: OrganizationalUnit;
  emitter?: User;
  message?: string;
  requestedResId?: string;
  creation?: ChangeInfo;
  lastUpdate?: ChangeInfo;

}

export namespace NotificationType {
  // tslint:disable-next-line:no-shadowed-variable
  export type NotificationTypeEnum = "ACCESS_DATASET_REQUEST" | "JOIN_ORG_UNIT_REQUEST";
  // tslint:disable-next-line:no-shadowed-variable
  export const NotificationTypeEnum = {
    ACCESS_DATASET_REQUEST: "ACCESS_DATASET_REQUEST" as NotificationTypeEnum,
    JOIN_ORG_UNIT_REQUEST: "JOIN_ORG_UNIT_REQUEST" as NotificationTypeEnum,
  };
}

export namespace NotificationStatus {
  // tslint:disable-next-line:no-shadowed-variable
  export type NotificationStatusEnum = "ACCEPTED" | "REFUSED" | "WAITING" | "ASKING";
  // tslint:disable-next-line:no-shadowed-variable
  export const NotificationStatusEnum = {
    ACCEPTED: "ACCEPTED" as NotificationStatusEnum,
    REFUSED: "REFUSED" as NotificationStatusEnum,
    WAITING: "WAITING" as NotificationStatusEnum,
    ASKING: "ASKING" as NotificationStatusEnum,
  };
}

export interface OaiSet extends OaiSetPartial {
}

export interface Oauth2Client extends Oauth2ClientPartial {
}

export namespace Oauth2Client {
  export type ScopeEnum = Oauth2ClientPartial.ScopeEnum;
  export const ScopeEnum = Oauth2ClientPartial.ScopeEnum;
}

export interface Order extends OrderPartial {
}

export namespace Order {
  export type QueryTypeEnum = OrderPartial.QueryTypeEnum;
  export const QueryTypeEnum = OrderPartial.QueryTypeEnum;
  export type StatusEnum = OrderPartial.StatusEnum;
  export const StatusEnum = OrderPartial.StatusEnum;
}

export interface OrganizationalUnit extends OrganizationalUnitPartial {
  defaultSubmissionPolicy?: SubmissionPolicy;
  defaultPreservationPolicy?: PreservationPolicy;
  defaultDisseminationPolicy?: DisseminationPolicy;
  submissionPolicies?: SubmissionPolicy[];
  preservationPolicies?: PreservationPolicy[];
  disseminationPolicies?: DisseminationPolicy[];
  fundingAgencies?: FundingAgency[];
  institutions?: Institution[];
  researchDomains?: ResearchDomain[];
  keywords?: string[];
  defaultLicense?: License;
}

export interface Page extends PagePartial {
}

export interface Person extends PersonPartial {
}

export interface Preingest extends PreingestPartial {
}

export interface PreservationJob extends PreservationJobPartial {
  scheduling?: PreservationJobScheduling;
}

export namespace PreservationJob {
  export type JobRecurrenceEnum = PreservationJobPartial.JobRecurrenceEnum;
  export const JobRecurrenceEnum = PreservationJobPartial.JobRecurrenceEnum;
  export type JobTypeEnum = PreservationJobPartial.JobTypeEnum;
  export const JobTypeEnum = PreservationJobPartial.JobTypeEnum;
}

export interface PreservationPlanning extends PreservationPlanningPartial {
}

export interface PreservationPolicy extends PreservationPolicyPartial {
}

export interface PreservationJobScheduling extends PreservationJobSchedulingPartial {
  weekDay?: string;
}

export interface ResearchDomain extends ResearchDomainPartial {
}

export interface ResourceSrv extends ResourceSrvPartial {
}

export interface Role extends RolePartial {
}

export interface Sip extends SipPartial {
}

export interface SubmissionAgreement extends SubmissionAgreementPartial {
}

export interface SubmissionPolicy extends SubmissionPolicyPartial {
}

export interface User extends UserPartial {
  person?: Person;
  accessToken?: string;
  refreshToken?: string;
}
