import {
  ChangeDetectionStrategy,
  Component,
  Inject,
  OnInit,
} from "@angular/core";
import {
  MAT_DIALOG_DATA,
  MatDialog,
  MatDialogRef,
} from "@angular/material/dialog";
import {Aip} from "@models";
import {
  Actions,
  Store,
} from "@ngxs/store";
import {
  SharedDetailDialog,
  SharedDetailDialogData,
} from "@shared/components/dialogs/shared-detail-dialog/shared-detail.dialog";
import {BreakpointService} from "@shared/services/breakpoint.service";
import {
  BaseResource,
  NotificationService,
} from "solidify-frontend";

@Component({
  selector: "dlcm-shared-aip-detail-dialog",
  templateUrl: "./shared-aip-detail.dialog.html",
  styleUrls: ["../shared-detail-dialog/shared-detail.dialog.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class SharedAipDetailDialog<TResource extends BaseResource> extends SharedDetailDialog<TResource> implements OnInit {

  constructor(protected readonly _store: Store,
              protected readonly _dialog: MatDialog,
              protected readonly _actions$: Actions,
              protected readonly _breakpointService: BreakpointService,
              protected readonly _notificationService: NotificationService,
              protected readonly dialogRef: MatDialogRef<SharedDetailDialog<TResource>>,
              @Inject(MAT_DIALOG_DATA) public data: SharedAipDetailDialogData<TResource>) {
    super(_store, _dialog, _actions$, _breakpointService, _notificationService, dialogRef, data);
  }

}

export interface SharedAipDetailDialogData<TResource extends BaseResource> extends SharedDetailDialogData<TResource> {
  aip: Aip;
}
