import {
  ChangeDetectionStrategy,
  Component,
  HostBinding,
  Input,
} from "@angular/core";
import {SharedAbstractPresentational} from "@shared/components/presentationals/shared-abstract/shared-abstract.presentational";

@Component({
  selector: "dlcm-shared-star-rating",
  templateUrl: "./shared-star-rating.presentational.html",
  styleUrls: ["./shared-star-rating.presentational.scss"],
  changeDetection: ChangeDetectionStrategy.OnPush,
})

export class SharedStarRatingPresentational extends SharedAbstractPresentational {
  @Input()
  rating: number;

  @Input()
  starsNumber: number = 3;

  @HostBinding("class.is-label")
  @Input()
  label: string | undefined;

  @Input()
  tooltipToTranslate: string | undefined;

  @HostBinding("class.is-disabled")
  @Input()
  disabled: boolean = false;

  @HostBinding("class.is-center")
  @Input()
  center: boolean = false;

  starsArray(): number[] {
    return Array(this.starsNumber);
  }
}
