import {Deposit} from "@models";
import {
  KeyValue,
  MARK_AS_TRANSLATABLE,
} from "solidify-frontend";

export class DepositStatusEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      {
        key: Deposit.StatusEnum.INPROGRESS,
        value: MARK_AS_TRANSLATABLE("IN_PROGRESS"),
      },
      {
        key: Deposit.StatusEnum.INVALIDATION,
        value: MARK_AS_TRANSLATABLE("IN_VALIDATION"),
      },
      {
        key: Deposit.StatusEnum.REJECTED,
        value: MARK_AS_TRANSLATABLE("REJECTED"),
      },
      {
        key: Deposit.StatusEnum.INERROR,
        value: MARK_AS_TRANSLATABLE("IN_ERROR"),
      },
      {
        key: Deposit.StatusEnum.PAUSED,
        value: MARK_AS_TRANSLATABLE("PAUSED"),
      },
      {
        key: Deposit.StatusEnum.CHECKED,
        value: MARK_AS_TRANSLATABLE("CHECKED"),
      },
      {
        key: Deposit.StatusEnum.REJECTED,
        value: MARK_AS_TRANSLATABLE("REJECTED"),
      },
      {
        key: Deposit.StatusEnum.APPROVED,
        value: MARK_AS_TRANSLATABLE("APPROVED"),
      },
      {
        key: Deposit.StatusEnum.SUBMITTED,
        value: MARK_AS_TRANSLATABLE("SUBMITTED"),
      },
      {
        key: Deposit.StatusEnum.COMPLETED,
        value: MARK_AS_TRANSLATABLE("COMPLETED"),
      },
      {
        key: Deposit.StatusEnum.CLEANING,
        value: MARK_AS_TRANSLATABLE("CLEANING"),
      },
      {
        key: Deposit.StatusEnum.CLEANED,
        value: MARK_AS_TRANSLATABLE("CLEANED"),
      },
    ];
  }
}
