import {Deposit} from "@models";
import {
  isNullOrUndefined,
  KeyValue,
  MARK_AS_TRANSLATABLE,
} from "solidify-frontend";
import AccessEnum = Deposit.AccessEnum;

export class EmbargoAccessLevelEnumHelper {
  static getAllListKeyValue(): KeyValue[] {
    return [
      {
        key: AccessEnum.PUBLIC,
        value: MARK_AS_TRANSLATABLE("enum.access.public"),
      },
      {
        key: AccessEnum.RESTRICTED,
        value: MARK_AS_TRANSLATABLE("enum.access.restricted"),
      },
      {
        key: AccessEnum.CLOSED,
        value: MARK_AS_TRANSLATABLE("enum.access.closed"),
      }
    ];
  }

  static getListKeyValue(access: AccessEnum): KeyValue[] {
    if (access === AccessEnum.PUBLIC) {
      return [
        {
          key: AccessEnum.RESTRICTED,
          value: MARK_AS_TRANSLATABLE("enum.access.restricted"),
        },
        {
          key: AccessEnum.CLOSED,
          value: MARK_AS_TRANSLATABLE("enum.access.closed"),
        }
      ];
    } else if (access === AccessEnum.RESTRICTED) {
      return [
        {
          key: AccessEnum.CLOSED,
          value: MARK_AS_TRANSLATABLE("enum.access.closed"),
        }
      ];
    }
  }

  static getLabel(key: string): string {
    const item = this.getAllListKeyValue().find(i => i.key === key);
    if (isNullOrUndefined(item)) {
      return key;
    }
    return item.value;
  }

}
