import {JobReportAipStatusEnum} from "@shared/enums/business/job-report-aip-status.enum";
import {
  KeyValue,
  MARK_AS_TRANSLATABLE,
} from "solidify-frontend";

export enum JobStatusEnum {
  IN_PROGRESS = "IN_PROGRESS",
  COMPLETED = "COMPLETED",
  READY = "READY",
  PAUSED = "PAUSED",
  IN_ERROR = "IN_ERROR"
}

export class JobStatusEnumHelper {
  static getExecutionReportStatus(): KeyValue[] {
    return [
      {
        key: JobReportAipStatusEnum.PROCESSED,
        value: MARK_AS_TRANSLATABLE("preservation.jobExecution.report.detail.jobStatusEnum.processed"),
      },
      {
        key: JobReportAipStatusEnum.IGNORED,
        value: MARK_AS_TRANSLATABLE("preservation.jobExecution.report.detail.jobStatusEnum.ignored"),
      },
      {
        key: JobReportAipStatusEnum.ERROR,
        value: MARK_AS_TRANSLATABLE("preservation.jobExecution.report.detail.jobStatusEnum.error"),
      },
    ];
  }

  static getExecutionStatus(): KeyValue[] {
    return [
      {
        key: JobStatusEnum.IN_PROGRESS,
        value: MARK_AS_TRANSLATABLE("preservation.jobExecution.jobStatusEnum.inProgress"),
      },
      {
        key: JobStatusEnum.COMPLETED,
        value: MARK_AS_TRANSLATABLE("preservation.jobExecution.jobStatusEnum.completed"),
      },
      {
        key: JobStatusEnum.READY,
        value: MARK_AS_TRANSLATABLE("preservation.jobExecution.jobStatusEnum.ready"),
      },
      {
        key: JobStatusEnum.PAUSED,
        value: MARK_AS_TRANSLATABLE("preservation.jobExecution.jobStatusEnum.paused"),
      },
      {
        key: JobStatusEnum.IN_ERROR,
        value: MARK_AS_TRANSLATABLE("preservation.jobExecution.jobStatusEnum.inError"),
      },
    ];
  }
}
