import {NotificationStatus} from "@models";
import {
  isNullOrUndefined,
  KeyValue,
  MARK_AS_TRANSLATABLE,
} from "solidify-frontend";
import NotificationStatusEnum = NotificationStatus.NotificationStatusEnum;

export class NotificationStatusEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      {
        key: NotificationStatusEnum.ACCEPTED,
        value: MARK_AS_TRANSLATABLE("notification.enum.notificationStatus.accepted"),
      },
      {
        key: NotificationStatusEnum.REFUSED,
        value: MARK_AS_TRANSLATABLE("notification.enum.notificationStatus.refused"),
      },
      {
        key: NotificationStatusEnum.WAITING,
        value: MARK_AS_TRANSLATABLE("notification.enum.notificationStatus.waiting"),
      },
      {
        key: NotificationStatusEnum.ASKING,
        value: MARK_AS_TRANSLATABLE("notification.enum.notificationStatus.asking"),
      },
    ];
  }

  static getLabel(key: string): string {
    const item = this.getListKeyValue().find(i => i.key === key);
    if (isNullOrUndefined(item)) {
      return key;
    }
    return item.value;
  }
}
