import {NotificationType} from "@models";
import {
  isNullOrUndefined,
  KeyValue,
  MARK_AS_TRANSLATABLE,
} from "solidify-frontend";
import NotificationTypeEnum = NotificationType.NotificationTypeEnum;

export class NotificationTypeEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      {
        key: NotificationTypeEnum.ACCESS_DATASET_REQUEST,
        value: MARK_AS_TRANSLATABLE("notification.enum.notificationType.accessDatasetRequest"),
      },
      {
        key: NotificationTypeEnum.JOIN_ORG_UNIT_REQUEST,
        value: MARK_AS_TRANSLATABLE("notification.enum.notificationType.joinOrgUnitRequest"),
      },
    ];
  }

  static getLabel(key: string): string {
    const item = this.getListKeyValue().find(i => i.key === key);
    if (isNullOrUndefined(item)) {
      return key;
    }
    return item.value;
  }
}
