import {DataCategoryEnum} from "@app/shared/enums/data-category.enum";
import {DataTypeEnum} from "@app/shared/enums/data-type.enum";
import {MARK_AS_TRANSLATABLE} from "solidify-frontend";

export class DataCategoryHelper {
  static getDataTypeForDataCategory(dataCategory: DataCategoryEnum): DataTypeEnum[] {
    switch (dataCategory) {
      case DataCategoryEnum.Primary:
        return [
          MARK_AS_TRANSLATABLE(DataTypeEnum.Observational) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.Experimental) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.Simulation) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.Derived) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.Reference) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.Digitalized) as DataTypeEnum,
        ];
      case DataCategoryEnum.Secondary:
        return [
          MARK_AS_TRANSLATABLE(DataTypeEnum.Publication) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.DataPaper) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.Documentation) as DataTypeEnum,
        ];
      case DataCategoryEnum.Package:
        return [
          MARK_AS_TRANSLATABLE(DataTypeEnum.InformationPackage) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.Metadata) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.CustomMetadata) as DataTypeEnum,
        ];
      case DataCategoryEnum.Software:
        return [
          MARK_AS_TRANSLATABLE(DataTypeEnum.Code) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.Binaries) as DataTypeEnum,
          MARK_AS_TRANSLATABLE(DataTypeEnum.VirtualMachine) as DataTypeEnum,
        ];
    }
  }

  static getListDataCategory(): DataCategoryEnum[] {
    return [
      MARK_AS_TRANSLATABLE(DataCategoryEnum.Primary) as DataCategoryEnum,
      MARK_AS_TRANSLATABLE(DataCategoryEnum.Secondary) as DataCategoryEnum,
      MARK_AS_TRANSLATABLE(DataCategoryEnum.Package) as DataCategoryEnum,
      MARK_AS_TRANSLATABLE(DataCategoryEnum.Software) as DataCategoryEnum,
    ];
  }
}
