import {OrderStatusEnumHelper} from "@order/enums/order-status.enum";
import {DataFileStatusEnumHelper} from "@shared/enums/business/data-file-status.enum";
import {DepositStatusEnumHelper} from "@shared/enums/business/deposit-status.enum";
import {PackageStatusEnumHelper} from "@shared/enums/business/package-status.enum";
import {
  KeyValue,
  MARK_AS_TRANSLATABLE,
} from "solidify-frontend";

export class HistoryStatusEnumHelper {
  static getListKeyValue(): KeyValue[] {
    return [
      ...PackageStatusEnumHelper.getListKeyValue(),
      ...OrderStatusEnumHelper.getListKeyValue(),
      ...DataFileStatusEnumHelper.getListKeyValue(),
      ...DepositStatusEnumHelper.getListKeyValue(),
      {
        key: "CREATED",
        value: MARK_AS_TRANSLATABLE("enum.historyStatus.created"),
      },
    ];
  }
}
