import {IconInfos} from "@shared/components/presentationals/shared-icon/shared-icon.presentational";
import {IconLibEnum} from "@shared/enums/icon-lib.enum";
import {IconNameEnum} from "@shared/enums/icon-name.enum";

export class IconHelper {
  static getIcon(name: IconNameEnum): IconInfos | undefined {
    return IconHelper.listIcon.find(i => i.name === name);
  }

  static listIcon: IconInfos[] = [
    {
      name: IconNameEnum.organizationalUnit,
      lib: IconLibEnum.fontAwesome,
      icon: "building",
    },
    {
      name: IconNameEnum.deposit,
      lib: IconLibEnum.fontAwesome,
      icon: "file-upload",
    },
    {
      name: IconNameEnum.home,
      lib: IconLibEnum.fontAwesome,
      icon: "home",
    },
    {
      name: IconNameEnum.order,
      lib: IconLibEnum.fontAwesome,
      icon: "cash-register",
    },
    {
      name: IconNameEnum.preservationSpace,
      lib: IconLibEnum.fontAwesome,
      icon: "users",
    },
    {
      name: IconNameEnum.preservationPlanning,
      lib: IconLibEnum.fontAwesome,
      icon: "boxes",
    },
    {
      name: IconNameEnum.administration,
      lib: IconLibEnum.fontAwesome,
      icon: "cogs",
    },
    {
      name: IconNameEnum.profile,
      lib: IconLibEnum.materialIcon,
      icon: "account_circle",
    },
    {
      name: IconNameEnum.token,
      lib: IconLibEnum.materialIcon,
      icon: "vpn_key",
    },
    {
      name: IconNameEnum.logout,
      lib: IconLibEnum.materialIcon,
      icon: "power_settings_new",
    },
    {
      name: IconNameEnum.login,
      lib: IconLibEnum.fontAwesome,
      icon: "sign-in-alt",
    },
    {
      name: IconNameEnum.resId,
      lib: IconLibEnum.fontAwesome,
      icon: "key",
    },
    {
      name: IconNameEnum.history,
      lib: IconLibEnum.materialIcon,
      icon: "history",
    },
    {
      name: IconNameEnum.docDev,
      lib: IconLibEnum.fontAwesome,
      icon: "code",
    },
    {
      name: IconNameEnum.docUser,
      lib: IconLibEnum.materialIcon,
      icon: "help",
    },
    {
      name: IconNameEnum.appVersion,
      lib: IconLibEnum.fontAwesome,
      icon: "code-branch",
    },
    {
      name: IconNameEnum.cart,
      lib: IconLibEnum.materialIcon,
      icon: "shopping_cart",
    },
    {
      name: IconNameEnum.addToCart,
      lib: IconLibEnum.materialIcon,
      icon: "add_shopping_cart",
    },
    {
      name: IconNameEnum.search,
      lib: IconLibEnum.fontAwesome,
      icon: "search",
    },
    {
      name: IconNameEnum.back,
      lib: IconLibEnum.materialIcon,
      icon: "navigate_before",
    },
    {
      name: IconNameEnum.refresh,
      lib: IconLibEnum.materialIcon,
      icon: "refresh",
    },
    {
      name: IconNameEnum.delete,
      lib: IconLibEnum.materialIcon,
      icon: "delete",
    },
    {
      name: IconNameEnum.deleteAll,
      lib: IconLibEnum.materialIcon,
      icon: "delete_forever",
    },
    {
      name: IconNameEnum.create,
      lib: IconLibEnum.materialIcon,
      icon: "add",
    },
    {
      name: IconNameEnum.internalLink,
      lib: IconLibEnum.materialIcon,
      icon: "open_in_new ",
    },
    {
      name: IconNameEnum.externalLink,
      lib: IconLibEnum.materialIcon,
      icon: "language",
    },
    {
      name: IconNameEnum.edit,
      lib: IconLibEnum.materialIcon,
      icon: "edit",
    },
    {
      name: IconNameEnum.close,
      lib: IconLibEnum.materialIcon,
      icon: "close",
    },
    {
      name: IconNameEnum.archiveBrowsing,
      lib: IconLibEnum.materialIcon,
      icon: "list",
    },
    {
      name: IconNameEnum.download,
      lib: IconLibEnum.materialIcon,
      icon: "file_download",
    },
    {
      name: IconNameEnum.sendRequest,
      lib: IconLibEnum.materialIcon,
      icon: "announcement",
    },
    {
      name: IconNameEnum.member,
      lib: IconLibEnum.materialIcon,
      icon: "account_circle",
    },
    {
      name: IconNameEnum.myOrder,
      lib: IconLibEnum.fontAwesome,
      icon: "user",
    },
    {
      name: IconNameEnum.allOrder,
      lib: IconLibEnum.fontAwesome,
      icon: "users",
    },
    {
      name: IconNameEnum.metadata,
      lib: IconLibEnum.materialIcon,
      icon: "assignment",
    },
    {
      name: IconNameEnum.files,
      lib: IconLibEnum.materialIcon,
      icon: "insert_drive_file",
    },
    {
      name: IconNameEnum.associateArchive,
      lib: IconLibEnum.materialIcon,
      icon: "link",
    },
    {
      name: IconNameEnum.collection,
      lib: IconLibEnum.materialIcon,
      icon: "collections_bookmark",
    },
    {
      name: IconNameEnum.navigate,
      lib: IconLibEnum.materialIcon,
      icon: "forward",
    },
    {
      name: IconNameEnum.reserveDoi,
      lib: IconLibEnum.materialIcon,
      icon: "library_books",
    },
    {
      name: IconNameEnum.submit,
      lib: IconLibEnum.materialIcon,
      icon: "done_all",
    },
    {
      name: IconNameEnum.approve,
      lib: IconLibEnum.materialIcon,
      icon: "check",
    },
    {
      name: IconNameEnum.unapprove,
      lib: IconLibEnum.materialIcon,
      icon: "close",
    },
    {
      name: IconNameEnum.wait,
      lib: IconLibEnum.materialIcon,
      icon: "access_time",
    },
    {
      name: IconNameEnum.save,
      lib: IconLibEnum.materialIcon,
      icon: "save",
    },
    {
      name: IconNameEnum.uploadFile,
      lib: IconLibEnum.materialIcon,
      icon: "publish",
    },
    {
      name: IconNameEnum.uploadStructuredFiles,
      lib: IconLibEnum.materialIcon,
      icon: "unarchive",
    },
    {
      name: IconNameEnum.filesView,
      lib: IconLibEnum.materialIcon,
      icon: "list",
    },
    {
      name: IconNameEnum.foldersView,
      lib: IconLibEnum.materialIcon,
      icon: "folder_open",
    },
    {
      name: IconNameEnum.preview,
      lib: IconLibEnum.materialIcon,
      icon: "remove_red_eye",
    },
    {
      name: IconNameEnum.star,
      lib: IconLibEnum.materialIcon,
      icon: "star",
    },
    {
      name: IconNameEnum.star_empty,
      lib: IconLibEnum.materialIcon,
      icon: "star_border",
    },
    {
      name: IconNameEnum.move,
      lib: IconLibEnum.materialIcon,
      icon: "redo",
    },
    {
      name: IconNameEnum.information,
      lib: IconLibEnum.materialIcon,
      icon: "info",
    },
    {
      name: IconNameEnum.contributor,
      lib: IconLibEnum.materialIcon,
      icon: "group",
    },
    {
      name: IconNameEnum.requestInbox,
      lib: IconLibEnum.materialIcon,
      icon: "mail",
    },
    {
      name: IconNameEnum.requestSent,
      lib: IconLibEnum.materialIcon,
      icon: "send",
    },
    {
      name: IconNameEnum.sip,
      lib: IconLibEnum.fontAwesome,
      icon: "paper-plane",
    },
    {
      name: IconNameEnum.dip,
      lib: IconLibEnum.fontAwesome,
      icon: "cart-arrow-down",
    },
    {
      name: IconNameEnum.aip,
      lib: IconLibEnum.fontAwesome,
      icon: "archive",
    },
    {
      name: IconNameEnum.monitoring,
      lib: IconLibEnum.fontAwesome,
      icon: "user-md",
    },
    {
      name: IconNameEnum.jobs,
      lib: IconLibEnum.fontAwesome,
      icon: "robot",
    },
    {
      name: IconNameEnum.archivingStatus,
      lib: IconLibEnum.fontAwesome,
      icon: "clipboard-check",
    },
    {
      name: IconNameEnum.aipDownloaded,
      lib: IconLibEnum.fontAwesome,
      icon: "cart-arrow-down",
    },
    {
      name: IconNameEnum.storagion,
      lib: IconLibEnum.fontAwesome,
      icon: "server",
    },
    {
      name: IconNameEnum.simpleChecksum,
      lib: IconLibEnum.materialIcon,
      icon: "refresh",
    },
    {
      name: IconNameEnum.doubleChecksum,
      lib: IconLibEnum.materialIcon,
      icon: "sync",
    },
    {
      name: IconNameEnum.reindex,
      lib: IconLibEnum.materialIcon,
      icon: "repeat",
    },
    {
      name: IconNameEnum.check,
      lib: IconLibEnum.materialIcon,
      icon: "check",
    },
    {
      name: IconNameEnum.init,
      lib: IconLibEnum.materialIcon,
      icon: "power",
    },
    {
      name: IconNameEnum.run,
      lib: IconLibEnum.materialIcon,
      icon: "play_arrow",
    },
    {
      name: IconNameEnum.resume,
      lib: IconLibEnum.materialIcon,
      icon: "play_circle_filled",
    },
    {
      name: IconNameEnum.notIgnore,
      lib: IconLibEnum.materialIcon,
      icon: "check_circle",
    },
    {
      name: IconNameEnum.submissionPolicies,
      lib: IconLibEnum.fontAwesome,
      icon: "user-check",
    },
    {
      name: IconNameEnum.preservationPolicies,
      lib: IconLibEnum.fontAwesome,
      icon: "history",
    },
    {
      name: IconNameEnum.disseminationPolicies,
      lib: IconLibEnum.fontAwesome,
      icon: "cart-arrow-down",
    },
    {
      name: IconNameEnum.licenses,
      lib: IconLibEnum.fontAwesome,
      icon: "copyright",
    },
    {
      name: IconNameEnum.institutions,
      lib: IconLibEnum.fontAwesome,
      icon: "university",
    },
    {
      name: IconNameEnum.researchDomains,
      lib: IconLibEnum.fontAwesome,
      icon: "microscope",
    },
    {
      name: IconNameEnum.users,
      lib: IconLibEnum.fontAwesome,
      icon: "user-circle",
    },
    {
      name: IconNameEnum.roles,
      lib: IconLibEnum.fontAwesome,
      icon: "id-badge",
    },
    {
      name: IconNameEnum.oaiSets,
      lib: IconLibEnum.fontAwesome,
      icon: "passport",
    },
    {
      name: IconNameEnum.oauth2Clients,
      lib: IconLibEnum.fontAwesome,
      icon: "passport",
    },
    {
      name: IconNameEnum.peoples,
      lib: IconLibEnum.fontAwesome,
      icon: "user",
    },
    {
      name: IconNameEnum.fundingAgencies,
      lib: IconLibEnum.fontAwesome,
      icon: "hand-holding-usd",
    },
    {
      name: IconNameEnum.languages,
      lib: IconLibEnum.fontAwesome,
      icon: "language",
    },
    {
      name: IconNameEnum.metadataTypes,
      lib: IconLibEnum.fontAwesome,
      icon: "table",
    },
    {
      name: IconNameEnum.notifications,
      lib: IconLibEnum.fontAwesome,
      icon: "envelope",
    },
    {
      name: IconNameEnum.passwordVisible,
      lib: IconLibEnum.fontAwesome,
      icon: "eye",
    },
    {
      name: IconNameEnum.passwordHide,
      lib: IconLibEnum.fontAwesome,
      icon: "eye-slash",
    },
    {
      name: IconNameEnum.testFile,
      lib: IconLibEnum.materialIcon,
      icon: "check",
    },
    {
      name: IconNameEnum.folderOpened,
      lib: IconLibEnum.fontAwesome,
      icon: "folder-open",
    },
    {
      name: IconNameEnum.folderClosed,
      lib: IconLibEnum.fontAwesome,
      icon: "folder",
    },
    {
      name: IconNameEnum.expandAll,
      lib: IconLibEnum.materialIcon,
      icon: "unfold_more",
    },
    {
      name: IconNameEnum.collapseAll,
      lib: IconLibEnum.materialIcon,
      icon: "unfold_less",
    },
    {
      name: IconNameEnum.send,
      lib: IconLibEnum.materialIcon,
      icon: "send",
    },
    {
      name: IconNameEnum.clear,
      lib: IconLibEnum.materialIcon,
      icon: "clear",
    },
    {
      name: IconNameEnum.done,
      lib: IconLibEnum.materialIcon,
      icon: "done",
    },
    {
      name: IconNameEnum.update,
      lib: IconLibEnum.materialIcon,
      icon: "sync",
    },
    {
      name: IconNameEnum.emptyCart,
      lib: IconLibEnum.materialIcon,
      icon: "archive",
    },
    {
      name: IconNameEnum.copyToClipboard,
      lib: IconLibEnum.materialIcon,
      icon: "filter_none",
    },
    {
      name: IconNameEnum.notFound,
      lib: IconLibEnum.materialIcon,
      icon: "mood_bad",
    },
    {
      name: IconNameEnum.up,
      lib: IconLibEnum.materialIcon,
      icon: "keyboard_arrow_up",
    },
    {
      name: IconNameEnum.down,
      lib: IconLibEnum.materialIcon,
      icon: "keyboard_arrow_down",
    },
    {
      name: IconNameEnum.personAdd,
      lib: IconLibEnum.materialIcon,
      icon: "person_add",
    },
    {
      name: IconNameEnum.redo,
      lib: IconLibEnum.fontAwesome,
      icon: "redo-alt",
    },
    {
      name: IconNameEnum.sort,
      lib: IconLibEnum.materialIcon,
      icon: "format_list_numbered_rtl",
    },
    {
      name: IconNameEnum.clearCache,
      lib: IconLibEnum.materialIcon,
      icon: "delete_sweep",
    },
    {
      name: IconNameEnum.warning,
      lib: IconLibEnum.materialIcon,
      icon: "warning",
    },
    {
      name: IconNameEnum.autoUpdate,
      lib: IconLibEnum.materialIcon,
      icon: "autorenew",
    },
    {
      name: IconNameEnum.fingerprint,
      lib: IconLibEnum.materialIcon,
      icon: "fingerprint",
    },
    {
      name: IconNameEnum.http,
      lib: IconLibEnum.materialIcon,
      icon: "http",
    },
    {
      name: IconNameEnum.closeChip,
      lib: IconLibEnum.fontAwesome,
      icon: "times-circle",
    },
    {
      name: IconNameEnum.success,
      lib: IconLibEnum.materialIcon,
      icon: "check_circle",
    },
    {
      name: IconNameEnum.error,
      lib: IconLibEnum.materialIcon,
      icon: "error",
    },
    {
      name: IconNameEnum.zoomOut,
      lib: IconLibEnum.materialIcon,
      icon: "zoom_out",
    },
    {
      name: IconNameEnum.zoomIn,
      lib: IconLibEnum.materialIcon,
      icon: "zoom_in",
    },
    {
      name: IconNameEnum.menuButtons,
      lib: IconLibEnum.fontAwesome,
      icon: "ellipsis-v",
    },
    {
      name: IconNameEnum.orcid,
      lib: IconLibEnum.image,
      icon: "orcid.png",
    },
    {
      name: IconNameEnum.doi,
      lib: IconLibEnum.image,
      icon: "doi.svg",
    },
    {
      name: IconNameEnum.archive,
      lib: IconLibEnum.fontAwesome,
      icon: "book",
    },
    {
      name: IconNameEnum.unigeBlack,
      lib: IconLibEnum.image,
      icon: "unigelogo-black.svg",
    },
    {
      name: IconNameEnum.unigeWhite,
      lib: IconLibEnum.image,
      icon: "unigelogo-white.svg",
    },
    {
      name: IconNameEnum.theme,
      lib: IconLibEnum.materialIcon,
      icon: "style",
    },
    {
      name: IconNameEnum.darkMode,
      lib: IconLibEnum.materialIcon,
      icon: "brightness_medium",
    },
    {
      name: IconNameEnum.creationDate,
      lib: IconLibEnum.materialIcon,
      icon: "event_note",
    },
  ];
}
