import {
  isNullOrUndefined,
  isNumber,
  StringUtil,
} from "solidify-frontend";

export class FileUtil {
  static transformFileSize(size: number): string {
    if (isNullOrUndefined(size) || !isNumber(size)) {
      return StringUtil.stringEmpty;
    }
    let extension: string;
    let newSize: number;
    if (size < 1024) {
      newSize = size;
      extension = " B";
    } else if (size < 1048576) {
      newSize = size / 1024;
      extension = " KB";
    } else if (size < 1073741824) {
      newSize = size / 1048576;
      extension = " MB";
    } else if (size < 1099511627776) {
      newSize = size / 1.073741824;
      extension = " GB";
    } else {
      newSize = size / 1.099511627776;
      extension = " TB";
    }
    return newSize.toFixed(2) + extension;
  }
}
