import {LocalStateEnum} from "@shared/enums/local-state.enum";
import {ArchiveMetadata} from "@shared/models/business/archive-metadata.model";
import {BaseAction} from "solidify-frontend";

const state = LocalStateEnum.application_cart;

export namespace AppCartAction {
  export class AddToCart {
    static readonly type: string = `[${state}] Add To Cart`;

    constructor(public archiveMetadata: ArchiveMetadata) {
    }
  }

  export class RemoveToCart {
    static readonly type: string = `[${state}] Remove To Cart`;

    constructor(public resId: string) {
    }
  }

  export class Clean {
    static readonly type: string = `[${state}] Clean`;
  }

  export class GetAllCart {
    static readonly type: string = `[${state}] Get All Cart`;
  }

  export class Submit extends BaseAction {
    static readonly type: string = `[${state}] Submit Cart`;
  }

  export class SubmitSuccess {
    static readonly type: string = `[${state}] Submit Success`;

    constructor(public orderId: string) {}
  }

  export class SubmitFail {
    static readonly type: string = `[${state}] Submit Fail`;

    constructor(public orderId: string) {}
  }
}

export const appCartActionNameSpace = AppCartAction;
