import {
  EventEmitter,
  Injectable,
} from "@angular/core";
import {
  Observable,
  of,
  Subject,
} from "rxjs";

@Injectable()
export class MockTranslateService {

  private _translation: Subject<any> = new Subject();
  private _translationObs: Observable<any> = this._translation.asObservable();

  onLangChange: EventEmitter<any> = new EventEmitter();
  onTranslationChange: EventEmitter<any> = new EventEmitter();
  onDefaultLangChange: EventEmitter<any> = new EventEmitter();

  constructor() {
  }

  get(labels: string[]): Observable<String[]> {
    return of(labels);
  }

  getTranslation(labels: string[]): Observable<any> {
    setTimeout(() => this._translation.next(""), 10);
    return this._translationObs;
  }

  instant(labels: string | string[]): string | string[] {
    return labels;
  }

}
